package paraboloide;

import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

import com.jogamp.newt.opengl.GLWindow;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.util.FPSAnimator;
import javax.swing.SpringLayout;
import java.awt.GridLayout;
import javax.swing.border.BevelBorder;

public class Main extends JFrame {

	GLWindow window;
	FPSAnimator animator;
	GLRenderer renderer;

	public Main() {
		setTitle("OpenGL");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(0, 0, 403, 216);
		JPanel contentPane = new JPanel();
		setContentPane(contentPane);
		

		// OpenGL
		window = GLWindow.create(new GLCapabilities(GLProfile.getDefault()));	// crea la finestra di rendering
		window.setTitle("OpenGL - GLWindow");									// imposta il titolo
		window.setSize(800, 600);												// imposta la dimensione
		renderer = new GLRenderer();											// istanzia la classe GLRenderer
		window.addGLEventListener(renderer); 									// passa all'ascolatore di eventi l'oggetto renderer
		animator = new FPSAnimator(window, 60, false);	

		JButton btnShow = new JButton("Show");
		btnShow.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				window.setVisible(true);
			}
		});
		SpringLayout sl_contentPane = new SpringLayout();
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnShow, 6, SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnShow, 6, SpringLayout.WEST, contentPane);
		contentPane.setLayout(sl_contentPane);
		contentPane.add(btnShow);

		JButton btnHide = new JButton("Hide");
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnHide, 6, SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnHide, 77, SpringLayout.WEST, contentPane);
		btnHide.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.setVisible(false);
			}
		});
		contentPane.add(btnHide);

		JToggleButton btnFullscreen = new JToggleButton("Fullscreen");
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnFullscreen, 6, SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnFullscreen, 140, SpringLayout.WEST, contentPane);
		btnFullscreen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.setFullscreen(btnFullscreen.isSelected());
			}
		});
		contentPane.add(btnFullscreen);

		JButton btnStart = new JButton("Start");
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnStart, 6, SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnStart, 237, SpringLayout.WEST, contentPane);
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				animator.start();
			}
		});
		contentPane.add(btnStart);

		JButton btnStop = new JButton("Stop");
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnStop, 6, SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnStop, 304, SpringLayout.WEST, contentPane);
		btnStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				animator.stop();
			}
		});
		contentPane.add(btnStop);
		
		JPanel panel = new JPanel();
		sl_contentPane.putConstraint(SpringLayout.WEST, panel, -1, SpringLayout.WEST, contentPane);
		sl_contentPane.putConstraint(SpringLayout.EAST, panel, 1, SpringLayout.EAST, contentPane);
		panel.setBorder(null);
		sl_contentPane.putConstraint(SpringLayout.NORTH, panel, 30, SpringLayout.NORTH, btnFullscreen);
		sl_contentPane.putConstraint(SpringLayout.SOUTH, panel, 0, SpringLayout.SOUTH, contentPane);
		contentPane.add(panel);
		panel.setLayout(null);
		
		JButton btnDown_1 = new JButton("DOWN");
		btnDown_1.setBounds(12, 95, 69, 25);
		panel.add(btnDown_1);
		btnDown_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				renderer.setZ0(renderer.getZ0()-0.5);
			}
		});
		sl_contentPane.putConstraint(SpringLayout.WEST, btnDown_1, 0, SpringLayout.WEST, contentPane);
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnDown_1, 10, SpringLayout.SOUTH, btnLeft);
		
		JButton btnUp_1 = new JButton("UP");
		btnUp_1.setBounds(12, 67, 69, 25);
		panel.add(btnUp_1);
		btnUp_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				renderer.setZ0(renderer.getZ0()+0.5);
			}
		});
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnUp_1, 18, SpringLayout.SOUTH, btnStop);
		
		JButton btnRight = new JButton("RIGHT");
		btnRight.setBounds(234, 27, 69, 25);
		panel.add(btnRight);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnRight, 0, SpringLayout.WEST, btnStart);
		sl_contentPane.putConstraint(SpringLayout.SOUTH, btnRight, -22, SpringLayout.NORTH, btnDown);
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnLeft, 0, SpringLayout.NORTH, btnRight);
		btnRight.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				renderer.setX0(renderer.getX0()+0.5);
			}
		});
		
		JButton btnDown = new JButton("BACKWARD");
		btnDown.setBounds(137, 55, 100, 25);
		panel.add(btnDown);
		btnDown.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				renderer.setY0(renderer.getY0()-0.5);
			}
		});
		sl_contentPane.putConstraint(SpringLayout.WEST, btnDown, 0, SpringLayout.WEST, btnFullscreen);
		sl_contentPane.putConstraint(SpringLayout.SOUTH, btnDown, -10, SpringLayout.SOUTH, contentPane);
		
		JButton btnUp = new JButton("FORWARD");
		btnUp.setBounds(137, 0, 100, 25);
		panel.add(btnUp);
		btnUp.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				renderer.setY0(renderer.getY0()+0.5);
			}
		});
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnUp, 6, SpringLayout.SOUTH, btnFullscreen);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnUp, -93, SpringLayout.EAST, btnFullscreen);
		sl_contentPane.putConstraint(SpringLayout.EAST, btnUp, 0, SpringLayout.EAST, btnFullscreen);
		
		JButton btnLeft = new JButton("LEFT");
		btnLeft.setBounds(72, 27, 69, 25);
		panel.add(btnLeft);
		btnLeft.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				renderer.setX0(renderer.getX0()-0.5);
			}
		});
		sl_contentPane.putConstraint(SpringLayout.EAST, btnLeft, 0, SpringLayout.EAST, btnHide);
						// istanzia la classe FPSAnimator, 60  la frequenza di rendering
	}

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}
}
